"use strict";const sw=self,VERSION=4,resourceCacheName=`vscode-resource-cache-${VERSION}`,rootPath=sw.location.pathname.replace(/\/service-worker.js$/,""),searchParams=new URL(location.toString()).searchParams,remoteAuthority=searchParams.get("remoteAuthority"),ID=searchParams.get("id"),resourceBaseAuthority=searchParams.get("vscode-resource-base-authority"),resolveTimeout=3e4;class RequestStore{constructor(){this.a=new Map,this.b=0}create(){const t=++this.b;let s;const o=new Promise(i=>s=i),r={resolve:s,promise:o};this.a.set(t,r);const l=setTimeout(()=>{clearTimeout(l);const i=this.a.get(t);i===r&&(i.resolve({status:"timeout"}),this.a.delete(t))},resolveTimeout);return{requestId:t,promise:o}}resolve(t,s){const o=this.a.get(t);return o?(o.resolve({status:"ok",value:s}),this.a.delete(t),!0):!1}}const resourceRequestStore=new RequestStore,localhostRequestStore=new RequestStore,unauthorized=()=>new Response("Unauthorized",{status:401}),notFound=()=>new Response("Not Found",{status:404}),methodNotAllowed=()=>new Response("Method Not Allowed",{status:405}),requestTimeout=()=>new Response("Request Timeout",{status:408});sw.addEventListener("message",async e=>{if(!e.source)return;const t=e.source;switch(e.data.channel){case"version":{sw.clients.get(t.id).then(s=>{s&&s.postMessage({channel:"version",version:VERSION})});return}case"did-load-resource":{const s=e.data.data;resourceRequestStore.resolve(s.id,s)||console.log("Could not resolve unknown resource",s.path);return}case"did-load-localhost":{const s=e.data.data;localhostRequestStore.resolve(s.id,s.location)||console.log("Could not resolve unknown localhost",s.origin);return}default:{console.log("Unknown message");return}}}),sw.addEventListener("fetch",e=>{const t=new URL(e.request.url);if(typeof resourceBaseAuthority=="string"&&t.protocol==="https:"&&t.hostname.endsWith("."+resourceBaseAuthority))switch(e.request.method){case"GET":case"HEAD":{const s=t.hostname.slice(0,t.hostname.length-(resourceBaseAuthority.length+1)),o=s.split("+",1)[0],r=s.slice(o.length+1);return e.respondWith(processResourceRequest(e,{scheme:o,authority:r,path:t.pathname,query:t.search.replace(/^\?/,"")}))}default:return e.respondWith(methodNotAllowed())}if(t.origin!==sw.origin&&t.host===remoteAuthority)switch(e.request.method){case"GET":case"HEAD":return e.respondWith(processResourceRequest(e,{path:t.pathname,scheme:t.protocol.slice(0,t.protocol.length-1),authority:t.host,query:t.search.replace(/^\?/,"")}));default:return e.respondWith(methodNotAllowed())}if(t.origin!==sw.origin&&t.host.match(/^(localhost|127.0.0.1|0.0.0.0):(\d+)$/))return e.respondWith(processLocalhostRequest(e,t))}),sw.addEventListener("install",e=>{e.waitUntil(sw.skipWaiting())}),sw.addEventListener("activate",e=>{e.waitUntil(sw.clients.claim())});async function processResourceRequest(e,t){const s=await sw.clients.get(e.clientId);let o;if(s)o=getWebviewIdForClient(s);else{const n=await getWorkerClientForId(e.clientId);if(n)o=getWebviewIdForClient(n);else return console.error("Could not find inner client for request"),notFound()}if(!o)return console.error("Could not resolve webview id"),notFound();const r=e.request.method==="GET",d=(n,g)=>{if(n.status==="timeout")return requestTimeout();const a=n.value;if(a.status===304){if(g)return g.clone();throw new Error("No cache found")}if(a.status===401)return unauthorized();if(a.status!==200)return notFound();const m={"Access-Control-Allow-Origin":"*"},p=a.data.byteLength,y=e.request.headers.get("range");if(y){const h=y.match(/^bytes\=(\d+)\-(\d+)?$/g);if(h){const R=Number(h[1]),q=Number(h[2])||p-1;return new Response(a.data.slice(R,q+1),{status:206,headers:{...m,"Content-range":`bytes 0-${q}/${p}`}})}else return new Response(null,{status:416,headers:{...m,"Content-range":`*/${p}`}})}const c={...m,"Content-Type":a.mime,"Content-Length":p.toString()};a.etag&&(c.ETag=a.etag,c["Cache-Control"]="no-cache"),a.mtime&&(c["Last-Modified"]=new Date(a.mtime).toUTCString());const w=new URL(e.request.url).searchParams.get("vscode-coi");w==="3"?(c["Cross-Origin-Opener-Policy"]="same-origin",c["Cross-Origin-Embedder-Policy"]="require-corp"):w==="2"?c["Cross-Origin-Embedder-Policy"]="require-corp":w==="1"&&(c["Cross-Origin-Opener-Policy"]="same-origin");const C=new Response(a.data,{status:200,headers:c});return r&&a.etag&&caches.open(resourceCacheName).then(h=>h.put(e.request,C)),C.clone()},l=await getOuterIframeClient(o);if(!l.length)return console.log("Could not find parent client for request"),notFound();let i;r&&(i=await(await caches.open(resourceCacheName)).match(e.request));const{requestId:f,promise:u}=resourceRequestStore.create();for(const n of l)n.postMessage({channel:"load-resource",id:f,scheme:t.scheme,authority:t.authority,path:t.path,query:t.query,ifNoneMatch:i?.headers.get("ETag")});return u.then(n=>d(n,i))}async function processLocalhostRequest(e,t){const s=await sw.clients.get(e.clientId);if(!s)return fetch(e.request);const o=getWebviewIdForClient(s);if(!o)return console.error("Could not resolve webview id"),fetch(e.request);const r=t.origin,d=async u=>{if(u.status!=="ok"||!u.value)return fetch(e.request);const n=u.value,g=e.request.url.replace(new RegExp(`^${t.origin}(/|$)`),`${n}$1`);return new Response(null,{status:302,headers:{Location:g}})},l=await getOuterIframeClient(o);if(!l.length)return console.log("Could not find parent client for request"),notFound();const{requestId:i,promise:f}=localhostRequestStore.create();for(const u of l)u.postMessage({channel:"load-localhost",origin:r,id:i});return f.then(d)}function getWebviewIdForClient(e){return e.type==="worker"||e.type==="sharedworker"?ID:new URL(e.url).searchParams.get("id")}async function getOuterIframeClient(e){return(await sw.clients.matchAll({includeUncontrolled:!0})).filter(s=>{const o=new URL(s.url);return(o.pathname===`${rootPath}/`||o.pathname===`${rootPath}/index.html`||o.pathname===`${rootPath}/index-no-csp.html`)&&o.searchParams.get("id")===e})}async function getWorkerClientForId(e){const t=await sw.clients.matchAll({type:"worker"}),s=await sw.clients.matchAll({type:"sharedworker"});return[...t,...s].find(r=>r.id===e)}

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/58746d045ea7f2870143bbb462a3f1d7b365f66d/core/vs/workbench/contrib/webview/browser/pre/service-worker.js.map
